AVR Libc Home Page |  | AVR Libc Development Pages
Main Page | User Manual | Library Reference | FAQ | Alphabetical Index | Example Projects

Macros
<avr/cpufunc.h>: Special AVR CPU functions

## Macros

#define | _NOP()
#define | _MemoryBarrier()

## Detailed Description

#include <avr/cpufunc.h>

This header file contains macros that access special functions of the AVR CPU which do not fit into any of the other header files.

## Macro Definition Documentation

#define _MemoryBarrier | ( |  | ) |

Implement a read/write memory barrier. A memory barrier instructs the compiler to not cache any memory data in registers beyond the barrier. This can sometimes be more effective than blocking certain optimizations by declaring some object with a `volatile` qualifier.

See optim_code_reorder for things to be taken into account with respect to compiler optimizations.

#define _NOP | ( |  | ) |

Execute a no operation (NOP) CPU instruction. This should not be used to implement delays, better use the functions from <util/delay_basic.h> or <util/delay.h> for this. For debugging purposes, a NOP can be useful to have an instruction that is guaranteed to be not optimized away by the compiler, so it can always become a breakpoint in the debugger.

Automatically generated by Doxygen 1.8.3.1 on Sun Sep 29 2013.